<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="auto"
      v-loading="formLoading"
      class="energy-device-check-dialog-form"
    >
      <el-row>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogDeviceIdLabel')" prop="deviceId">
            <el-input v-model="formData.deviceId" :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogDeviceIdPlaceholder')" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckTimeLabel')" prop="lastCheckTime">
            <el-date-picker
              v-model="formData.lastCheckTime"
              type="date"
              value-format="x"
              :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckTimePlaceholder')"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckValueLabel')" prop="lastCheckValue">
            <el-input v-model="formData.lastCheckValue" :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogLastCheckValuePlaceholder')" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-row>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogCheckTimeLabel')" prop="checkTime">
            <el-date-picker
              v-model="formData.checkTime"
              type="date"
              value-format="x"
              :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogCheckTimePlaceholder')"
            />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogCheckValueLabel')" prop="checkValue">
            <el-input v-model="formData.checkValue" :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogCheckValuePlaceholder')" />
          </el-form-item>
        </el-col>
      </el-row>
      <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogDiffValueLabel')" prop="diffValue">
        <el-input v-model="formData.diffValue" :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogDiffValuePlaceholder')" />
      </el-form-item>
      <el-row>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogUnitPriceLabel')" prop="unitPrice">
            <el-input v-model="formData.unitPrice" :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogUnitPricePlaceholder')" />
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item :label="t('EnergyManagement.EnergyDeviceCheck.dialogRemarkLabel')" prop="remark">
            <el-input v-model="formData.remark" :placeholder="t('EnergyManagement.EnergyDeviceCheck.dialogRemarkPlaceholder')" />
          </el-form-item>
        </el-col>
      </el-row>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('EnergyManagement.EnergyDeviceCheck.dialogOkButtonText') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('EnergyManagement.EnergyDeviceCheck.dialogCancelButtonText') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { EnergyDeviceCheckRecordApi, EnergyDeviceCheckRecordVO } from '@/api/mes/energydevicecheck'

/** 抄表记录 表单 */
defineOptions({ name: 'EnergyDeviceCheckRecordForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deviceId: undefined,
  lastCheckTime: undefined,
  lastCheckValue: undefined,
  checkValue: undefined,
  checkTime: undefined,
  diffValue: undefined,
  unitPrice: undefined,
  remark: undefined
})
const formRules = reactive({
  deviceId: [{ required: true, message: t('EnergyManagement.EnergyDeviceCheck.validatorDeviceIdRequired'), trigger: 'blur' }],
  checkValue: [{ required: true, message: t('EnergyManagement.EnergyDeviceCheck.validatorCheckValueRequired'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await EnergyDeviceCheckRecordApi.getEnergyDeviceCheckRecord(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as EnergyDeviceCheckRecordVO
    if (formType.value === 'create') {
      await EnergyDeviceCheckRecordApi.createEnergyDeviceCheckRecord(data)
      message.success(t('common.createSuccess'))
    } else {
      await EnergyDeviceCheckRecordApi.updateEnergyDeviceCheckRecord(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deviceId: undefined,
    lastCheckTime: undefined,
    lastCheckValue: undefined,
    checkValue: undefined,
    checkTime: undefined,
    diffValue: undefined,
    unitPrice: undefined,
    remark: undefined
  }
  formRef.value?.resetFields()
}
</script>
